package com.api.processDocuments;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;

import jakarta.servlet.ServletContext;
import jakarta.servlet.ServletException;
import jakarta.servlet.annotation.MultipartConfig;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.Part;
import java.io.File;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;
@MultipartConfig
public class FileUploadServlet extends HttpServlet 
{
    private static final long serialVersionUID = 1L;

    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException 
    {
        Part filePart = request.getPart("fileAadhar");
        Part filePart1 = request.getPart("panCard");
        Part filePart2 = request.getPart("voteId");
        Part filePart3 = request.getPart("passport");
        String localAadhaarInput = request.getParameter("hiddenAadhaarInput");
        String localPanInput = request.getParameter("hiddenPanInput");
        String localVoteIdInput = request.getParameter("hiddenVoteIdInput");
        String localPassportInput = request.getParameter("hiddenPassportInput");
        String localUserNameInput = request.getParameter("hiddenUserNameInput");
        String localDOBInput = request.getParameter("hiddenDOBInput");

        System.out.println("Local Aadhaar Number:"+ localAadhaarInput);
        System.out.println("Local Pan Number:"+ localPanInput);
        
        String validationStatus = null;
        String validationStatus1 = null;
        String validationStatus2 = null;
        String validationStatus3 = null;
        
        // Create a temporary file
        File tempFile = File.createTempFile("uploadedFile", ".tmp");
        File tempFile1 = File.createTempFile("uploadedFile", ".tmp");
        File tempFile2 = File.createTempFile("uploadedFile", ".tmp");
        File tempFile3 = File.createTempFile("uploadedFile", ".tmp");

        try (InputStream fileContent = filePart.getInputStream()) 
        {
            // Copy the content of the uploaded file to the temporary file
            Files.copy(fileContent, tempFile.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }
        try (InputStream fileContent1 = filePart1.getInputStream()) 
        {
            // Copy the content of the uploaded file to the temporary file
            Files.copy(fileContent1, tempFile1.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }
        try (InputStream fileContent2 = filePart2.getInputStream()) 
        {
            // Copy the content of the uploaded file to the temporary file
            Files.copy(fileContent2, tempFile2.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }
        try (InputStream fileContent3 = filePart3.getInputStream()) 
        {
            // Copy the content of the uploaded file to the temporary file
            Files.copy(fileContent3, tempFile3.toPath(), StandardCopyOption.REPLACE_EXISTING);
        }

		try 
		{
			validationStatus = GetToken.getBearerToken(tempFile);
			validationStatus1 = GetToken.getBearerToken(tempFile1);
			validationStatus2 = GetToken.getBearerToken(tempFile2);
			validationStatus3 = GetToken.getBearerToken(tempFile3);
	    	

		} 
		catch (Exception e)
		{
				e.printStackTrace();
		}
    

    	String[] aadharList = validationStatus.split("__ ");
    	if (validationStatus.startsWith("Valid")) {
			String aNo = aadharList[1];
         	request.setAttribute("localAadhaarInput", localAadhaarInput);	
         	request.setAttribute("localPanInput", localPanInput);	
         	request.setAttribute("localVoteIdInput", localVoteIdInput);	
         	request.setAttribute("localPassportInput", localPassportInput);	
         	request.setAttribute("localUserNameInput", localUserNameInput);	
         	request.setAttribute("localDOBInput", localDOBInput);	
         	request.setAttribute("aadhaarNumberValue", aNo);
            request.setAttribute("validationResult", "Valid");
            request.setAttribute("aadhaarName", aadharList[2]);           
            request.setAttribute("aadhaarDOB", aadharList[3]);
            
        } else {
        		String aNo = aadharList[1];
        		request.setAttribute("validationResult", "InValid");
        		request.setAttribute("localAadhaarInput", localAadhaarInput);	
             	request.setAttribute("localPanInput", localPanInput);	
             	request.setAttribute("localVoteIdInput", localVoteIdInput);	
             	request.setAttribute("localPassportInput", localPassportInput);	
             	request.setAttribute("localUserNameInput", localUserNameInput);	
             	request.setAttribute("localDOBInput", localDOBInput);	
             	request.setAttribute("aadhaarNumberValue", aNo);
                request.setAttribute("aadhaarName", aadharList[2]);           
                request.setAttribute("aadhaarDOB", aadharList[3]);

        }  
    	
    	String[] panList = validationStatus1.split("__ ");
    	
    	if (validationStatus1.startsWith("Valid")) {
	
        	String panNo = panList[1];
        	       		
        	request.setAttribute("panNumberValue", panNo);
    	}
    	else {
    		String panNo = panList[1];
       		
        	request.setAttribute("panNumberValue", panNo);
    	}
    	
    	String[] voteIdList = validationStatus2.split("__ ");
    	
    	if (validationStatus2.startsWith("Valid")) {
		
        	String voteId = voteIdList[1];
        
        	request.setAttribute("voteIdValue", voteId);
    	}
    	else {
    		String voteId = voteIdList[1];
            
        	request.setAttribute("voteIdValue", voteId);
    	}
    	
    	String[] passportList = validationStatus3.split("__ ");
    	if (validationStatus3.startsWith("Valid")) {
		
        	String passportNo = passportList[1];
        	
        	request.setAttribute("passportNumberValue", passportNo);
    	}
    	else {
    		String passportNo = passportList[1];
        	
        	request.setAttribute("passportNumberValue", passportNo);
    	
    	}
        request.getRequestDispatcher("/carLoan_applyNow2.jsp").forward(request, response);
    }

	private boolean isNumeric(String string) {
		// TODO Auto-generated method stub
		return false;
	}
}