package com.api.processDocuments;

import java.io.File;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.Base64;
import org.json.JSONObject;

import com.api.validateDetails.ValidateAadhar;

public class GetToken 
{
    public static String getBearerToken(File uploadedDocument) throws Exception
    {
        //String clientId = "";
        //String clientSecret = "";
        //String tokenEndpoint = "https://vantage-us.abbyy.com/auth2/8b71b94c-4e08-414c-88f4-b319b64abc1b/connect/token";
        
    	String clientId = "jQtyxVfQsGKaSIawbbfAnfjtKoFiVW";
        String clientSecret = "LG_BvPoJSDursHtAWCJlooXajvhtV5Alru";
        String tokenEndpoint = "https://vantage-us.abbyy.com/auth2/dc92e21e-9253-40f2-82fb-655e27a6dbe3/connect/token";
        
    	
    	
    	String validationStatus = "Valid";

        //Obtain Bearer Token
        String token = getBearerToken(clientId, clientSecret, tokenEndpoint);
        //System.out.println(token);
        
        //Get Available Skills
        //GetSkills.getAvailableSkill(token);
        
        //Upload Files And Initiate Transaction
        validationStatus = UploadDocumentsAndLaunch.uploadFilesAndInitiateTransaction(token, uploadedDocument);
        
        
        return validationStatus;

    }

    private static String getBearerToken(String clientId, String clientSecret, String tokenEndpoint) throws Exception 
    {
        String credentials = clientId + ":" + clientSecret;
        String encodedCredentials = Base64.getEncoder().encodeToString(credentials.getBytes());

        HttpClient client = HttpClient.newHttpClient();

        HttpRequest request = HttpRequest.newBuilder()
                .uri(URI.create(tokenEndpoint))
                .header("Authorization", "Basic " + encodedCredentials)
                .header("Content-Type", "application/x-www-form-urlencoded")
                .POST(HttpRequest.BodyPublishers.ofString("grant_type=client_credentials"))
                .build();

        HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());

        // Extract Bearer Token from the response
        String responseBody = response.body();
        System.out.println(responseBody);
        JSONObject jsonResponse = new JSONObject(responseBody);
        return jsonResponse.getString("access_token");       
     }
    
}

