
const Id = document.querySelector(".value");
const Name = document.querySelector(".Name .value");
const approvalAmount = document.querySelector(".Approval-Amount .value");
const interestRate = document.querySelector(".Interest-Rate .value");
const tenure = document.querySelector(".Tenure .value");
const loanEmi = document.querySelector(".Loan-EMI .value");
const totalAmount = document.querySelector(".Total-Amount .value");

const details = document.querySelector(".Application-details");

/* Applicant Details Code */
var loanAmount= (Math.floor(Math.random() * 29 + 1)) * 50000;
var loanRate = (7.5 + Math.random()).toFixed(1);
var loanTenure = Month();

var interest = loanRate / 12 / 100;

function reloadpage() {
    Id.innerHTML = applicantId();
    Name.innerHTML = applicantName();
    approvalAmount.innerHTML = loanAmount;
    interestRate.innerHTML = loanRate + "%";
    tenure.innerHTML = loanTenure;
    var emi = Emi();
    loanEmi.innerHTML = Math.round(emi);
    totalAmount.innerHTML = Math.round(emi * loanTenure);
}

function applicantId() {
    const dateObj = new Date();
    var day = dateObj.getUTCDate();
    day = day.toString().padStart(2, "0");
    var year = dateObj.getUTCFullYear() % 100;
    var randomId = Math.floor(Math.random() * (9999 - 1000 + 1)) + 1000;

    return year + "" + day + "" + randomId;
}

function applicantName() {
    const namestr = ["Kamal", "Pradeep", "Garima", "Manu", "Abhishek", "Nithin", "Surya"]
    var randomId = Math.floor(Math.random() * 7);

    return namestr[randomId];
}

function Month() {
    const month = [12, 24, 36, 48, 60, 72, 84];
    return month[Math.floor(Math.random() * 7)];
}

function Emi() {
    var emi = loanAmount * interest * (Math.pow(1 + interest, loanTenure) / (Math.pow(1 + interest, loanTenure) - 1));
    return emi;
}

/* ---- ----- ----- */

/* Bank Validation */

const form = document.forms['form-action'];
const ifscCode = document.getElementById("ifsc");
const bankname = document.getElementById("bank-name");
const approvalAmountOutput = document.getElementById("approval-amount");

approvalAmountOutput.value = loanAmount;

function bankSubmit() {
    var value = 1;
    if (form.AccountNumber.value === "") {
        value = 0;
    }
    if (form.IFSC.value === "") {
        value = 0;
    }
    if (form.bankname.value === "") {
        value = 0;
    }
    if (value) {
        document.querySelector(".container").style.display = "block";
        progressBar();
    }
    event.preventDefault();
}


function ifscCodeValidation() {

    var errorMessage = document.querySelector('.error');
    var reg = new RegExp("[A-Z a-z]{4}[0][0-9]{6}");
    ifscCode.value = ifscCode.value.toUpperCase()
    var ifscMatch = -1;

    if (ifscCode.value.match(reg)) {
        ifscMatch = ifscBank();
    }
        if (ifscMatch > -1) {
            errorMessage.style.display = "block";
            errorMessage.style.backgroundColor = "#d2ffd2";
            errorMessage.style.color = "green";
            errorMessage.innerHTML = "Successfully Vaildated";
        }
        else if (ifscCode.value === "") {
            errorMessage.style.display = "none";
            bankname.value = "";
        }
        else {
            errorMessage.style.display = "block";
            errorMessage.innerHTML = "InVaild IFSC Code";
            errorMessage.style.backgroundColor = "#fde8ec";
            errorMessage.style.color = "#af4242";
            bankname.value = "";
        }
}

function ifscBank() {
    var nameBank = ["ICICI Bank", "HDFC Bank", "Kotak Mahindra Bank", "SBI Bank of India", "Canara Bank", "Axis Bank", "IndusInd Bank"];
    var bankifscCode = ["ICIC", "HDFC", "KKBK", "SBIN", "CNRB", "UTIB", "INDB"]

    var bank = (ifscCode.value).substring(0, 4);

    for (var i = 0; i < bankifscCode.length; i++) {
        if (bank === bankifscCode[i]) {
            bankname.value = nameBank[i];
            return i;
        }
    }
}

/* ---- ---- ---- */

/*Modal Trigger */
var Bankmodal = document.querySelector('.bank-modal-container');

function bankModal() {
    Bankmodal.style.display = "block";
}
function bankClose() {
    Bankmodal.style.display = "none";
}
/* ----- ----- ----- */

/* Payment Mode */
var container = document.querySelector(".container");
var paymentMode = document.querySelector(".paymentMode");
var fill = document.querySelector(".fill");

function progressBar() {
    var a = 0;
    var run = setInterval(frames, 10);
    function frames() {
        a = a + 1;
        if (a == 101) {
            clearInterval(run);
            container.style.display = "block";
            paymentMode.style.display = "block";
            Bankmodal.style.display = "none";
            document.querySelector(".Applicant").style.display = "none";
        }
        else {
            fill.style.width = a + "%";
        }
    }
}
/* ---- ---- ---- */